﻿using Plane.FormationCreator.Formation;
using Plane.FormationCreator.ViewModels;
using MahApps.Metro.Controls;
using Microsoft.Practices.ServiceLocation;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Plane.FormationCreator.Util;

namespace Plane.FormationCreator.Views
{
    /// <summary>
    /// Interaction logic for LoginWindow.xaml
    /// </summary>
    public partial class ConnectWindow : MetroWindow
    {
        public ConnectWindow()
        {
            this.DataContextChanged += (sender, e) =>
            {
                var vm = e.NewValue as ConnectViewModel;
                if (vm != null)
                {
                    vm.SetCloseWindowAction(this.Close);
                }
            };

            InitializeComponent();

            this.DataContext = ServiceLocator.Current.GetInstance<ConnectViewModel>();

            if (!VersionControl.IsFullVersion)
            {
                panel1.Visibility = Visibility.Collapsed;
                panel2.Visibility = Visibility.Collapsed;
                panel3.Visibility = Visibility.Collapsed;
            }

            txtIPs.Focus();
        }
    }
}
